﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Cluster.Clunet.Console
{
    public partial class RcButtonLearn : Form
    {
        public byte[] ButtonCode { get; private set; }
        public bool IsRaw { get; private set; }
        private string codeToShow = "";

        public RcButtonLearn(ClunetConnection clunetConnection, byte[] button = null)
        {
            InitializeComponent();
            IsRaw = false;
            ButtonCode = null;
            clunetConnection.OnPacketReceived += clunetConnection_OnPacketReceived;
            if (button != null)
            {
                textBoxButtonCode.Text = "";
                foreach (var b in button)
                    textBoxButtonCode.Text += string.Format("{0:X2}", b);
            }
        }

        void clunetConnection_OnPacketReceived(ClunetPacket packet)
        {
            if (((ClunetPacket.CommandType)packet.Command) == ClunetPacket.CommandType.RcButtonPressed)
            {
                if (packet.Data[0] % 2 == 0) packet.Data[0]--;
                IsRaw = false;
                //ButtonCode = packet.Data;
                codeToShow = packet.DataAsHex;
            }
            else if (((ClunetPacket.CommandType)packet.Command) == ClunetPacket.CommandType.RcRawButtonPressed)
            {
                IsRaw = true;
                //ButtonCode = packet.Data;
                codeToShow = "Raw: " + packet.DataAsHex;
            }
            ShowButton();
        }

        private delegate void ShowButtonFromThread();
        private void ShowButton()
        {
            if (InvokeRequired)
            {
                this.Invoke(new ShowButtonFromThread(ShowButton));
                return;
            }
            textBoxButtonCode.Text = codeToShow;
        }

        private void textBoxButtonCode_TextChanged(object sender, EventArgs e)
        {
            try
            {
                ButtonCode = new byte[textBoxButtonCode.Text.Length / 2];
                for (int i = 0; i < textBoxButtonCode.Text.Length / 2; i++)
                {
                    ButtonCode[i] = byte.Parse(textBoxButtonCode.Text.Substring(i * 2, 2), NumberStyles.AllowHexSpecifier);
                }
            }
            catch
            {
                ButtonCode = new byte[0];
            }
        }

    }
}
