﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;

namespace Cluster.Clunet.Flasher
{
    class Program
    {
        const byte LocalAddress = 0x00;
        const string password = "password";
        static ClunetConnection clunetConnection;
        static string host;
        static int port;
        static byte address;
        static string hexFile;
        static int pageSize = 0;
        static int currentPos = -1;
        static int startPos = -1;
        static byte[] hex;
        static int time = 0;
        static bool done = false;
        static int result = 1;
        static int repeats = 0;
        static int procInLine = 0;

        static int Main(string[] args)
        {
            try
            {
                if (args.Length < 4)
                {
                    Console.WriteLine("Use: ClunetFlaher.exe <ip> <port> <device_ID>|auto <HEX_file> [/bootupdate]");
                    return result;
                }
                host = args[0];
                port = int.Parse(args[1]);
                hexFile = args[3];
                if (args[2].ToLower() == "auto")
                {
                    var config = File.ReadAllLines(Path.Combine(Path.GetDirectoryName(hexFile), "clunet_config.h"));
                    foreach (var configLine in config)
                    {
                        if (configLine.StartsWith("#define") && configLine.Contains("CLUNET_DEVICE_ID"))
                        {
                            var cols = configLine.Split();
                            address = byte.Parse(cols[cols.Length - 1].Trim());
                            Console.WriteLine("Autodetected address: " + address);
                        }
                    }
                }
                else address = byte.Parse(args[2]);
                //updateBootMode = args.Length >= 5 && args[4].ToLower().Equals("/bootupdate");

                Console.WriteLine("Loading HEX");
                hex = LoadHex(hexFile);
                //if (!updateBootMode && startPos != -1 && startPos > 0)
                //{
                //    Console.WriteLine("Seems like bootloader file, use /bootupdate");
                //    return 1;
                //}
                Console.WriteLine("Loaded {0} bytes", hex.Length);
                clunetConnection = new ClunetConnection(host, port, password);
                clunetConnection.OnPacketReceived += clunetConnection_OnPacketReceived;
                Console.WriteLine("Connecting to " + host + "...");
                clunetConnection.Connect();
                int timeout = 3000;
                while (!clunetConnection.Connected && timeout > 0)
                {
                    Thread.Sleep(100);
                    timeout -= 100;
                }
                if (timeout <= 0) throw new Exception("Can't connect");
                Console.WriteLine("Connected: "+ clunetConnection.Connected);
                Console.WriteLine("Reboot command...");
                clunetConnection.Send(new ClunetPacket(ClunetPacket.PacketPriority.Command, 0x00, address, ClunetPacket.CommandType.Reboot));
                Thread.Sleep(3000);
                if (pageSize == 0) // Мож оно уже в загрузчике?
                    clunetConnection.Send(new ClunetPacket(ClunetPacket.PacketPriority.Command, 0x00, address, ClunetPacket.CommandType.BootControl, new byte[] { 1 }));

                while (!done)
                {
                    Thread.Sleep(100);
                    time++;
                    if (time > 50)
                    {
                        if (pageSize == 0)
                        {
                            if (repeats >= 10)
                            {
                                Console.WriteLine("Timeout.");
                                result = 2;
                                break;
                            }
                            Console.WriteLine("Timeout, repeating...");
                            clunetConnection.Send(new ClunetPacket(ClunetPacket.PacketPriority.Command, 0x00, address, ClunetPacket.CommandType.Reboot));
                            repeats++;
                        }
                        else
                        {
                            if (repeats >= 5)
                            {
                                Console.WriteLine("Too many errors.");
                                result = 2;
                                break;
                            }
                            Console.WriteLine("Timeout, repeating...");
                            WritePage();
                            repeats++;
                        }
                        time = 0;
                    }
                }
                clunetConnection.Disconnect();
                return result;
            }
            catch (Exception ex)
            {
                Console.WriteLine("Exception: " + ex.Message + ex.StackTrace);
                return 3;
            }
        }

        static void clunetConnection_OnPacketReceived(ClunetPacket packet)
        {
            if (packet.SrcAddress != address || packet.Command != (byte)ClunetPacket.CommandType.BootControl || packet.Length < 1) return;
            byte bootCommand = packet.Data[0];
            time = 0;
            switch (bootCommand)
            {
                case 0:
                    Console.WriteLine("Bootloader detected.");
                    clunetConnection.Send(new ClunetPacket(ClunetPacket.PacketPriority.Command, LocalAddress, address, ClunetPacket.CommandType.BootControl, new byte[] { 1 }));
                    break;
                case 2:
                    pageSize = packet.Data[1] | (packet.Data[2] << 8);
                    //                    currentPos = 0;
                    Console.WriteLine("Page size: " + pageSize + " bytes.");
                    repeats = 0;
                    WritePage();
                    break;
                case 4:
                    currentPos += pageSize;
                    repeats = 0;
                    WritePage();
                    break;
            }
        }

        static byte[] LoadHex(string path)
        {
            var result = new byte[256 * 1024];
            int maxAddr = 0;
            var text = File.OpenText(path);
            string line;
            while ((line = text.ReadLine()) != null)
            {
                var byteCount = int.Parse(line.Substring(1, 2), NumberStyles.AllowHexSpecifier);
                var addr = (int.Parse(line.Substring(3, 2), NumberStyles.AllowHexSpecifier) << 8) | int.Parse(line.Substring(5, 2), NumberStyles.AllowHexSpecifier);
                if (currentPos < 0) currentPos = startPos = addr;
                if (line.Substring(7, 1) == "0")
                    for (int i = 0; i < byteCount; i++)
                    {
                        result[addr + i] = byte.Parse(line.Substring(9 + i * 2, 2), NumberStyles.AllowHexSpecifier);
                        if (addr + i > maxAddr) maxAddr = addr + i;
                    }
            }
            var realResult = new byte[maxAddr + 1];
            Array.Copy(result, realResult, maxAddr + 1);
            return realResult;
        }

        static void WritePage()
        {
            Thread.Sleep(100);
            if (currentPos < hex.Length)
            {
                var buf = new byte[pageSize + 5];
                buf[0] = 3;
                buf[1] = (byte)(currentPos & 0xFF);
                buf[2] = (byte)((currentPos >> 8) & 0xFF);
                buf[3] = (byte)((currentPos >> 16) & 0xFF);
                buf[4] = (byte)((currentPos >> 24) & 0xFF);
                Array.Copy(hex, currentPos, buf, 5, Math.Min(pageSize, hex.Length - currentPos));
                string proc = (100 * (currentPos - startPos) / (hex.Length - startPos)).ToString() + "% ";
                Console.Write(proc);
                procInLine++;
                if (procInLine >= 20)
                {
                    Console.WriteLine();
                    procInLine = 0;
                }
                clunetConnection.Send(new ClunetPacket(ClunetPacket.PacketPriority.Command, LocalAddress, address, ClunetPacket.CommandType.BootControl, buf));
            }
            else
            {
                Console.WriteLine("100%");
                Console.WriteLine("Done.");
                clunetConnection.Send(new ClunetPacket(ClunetPacket.PacketPriority.Command, LocalAddress, address, ClunetPacket.CommandType.BootControl, new byte[] { 5 }));
                Thread.Sleep(500);
                result = 0;
                done = true;
            }
        }
    }
}
